Holger's Java API

## com.antelmann.util.gui
Class JCategoryField

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  javax.swing.JPanel
                      com.antelmann.util.gui.JCategoryField

All Implemented Interfaces:
  EditableComponent, ValueRetriever<Category<?>>, ValueSetter<Category<?>>, ImageObserver, MenuContainer, Serializable, Accessible

    public class JCategoryField

extends JPanel
implements ValueSetter<Category<?>>, ValueRetriever<Category<?>>, EditableComponent

fires a `PropertyChangeEvent` with key 'value' upon changes

Since:
  28.08.2011, 00:54:33
Author:
  Holger Antelmann
See Also:
  `CategoryNode`, Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class javax.swing.JPanel
`JPanel.AccessibleJPanel`

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JCategoryField(CategoryManager cmanager, Object context)`
`JCategoryField(CategoryManager cmanager, ValueRetriever<?> contextReceiver)`
`JCategoryField(Collection<Category<?>> topCategories, Object context)`
`JCategoryField(Collection<Category<?>> topCategories, Object context, boolean withClearButton)`
`JCategoryField(DBClassStore<?> store)` convenience constructor assuming that the given store implements `CategoryManager` and is based on a category using the `Database` as context
`JCategoryField(List<? extends Category<?>> topCategories, Object context)`
`JCategoryField(List<? extends Category<?>> topCategories, Object context, boolean withClearButton)`
`JCategoryField(ValueRetriever<Collection<Category<?>>> topCategoriesRetriever, ValueRetriever<?> contextRetriever)`
`JCategoryField(ValueRetriever<Collection<Category<?>>> topCategoriesRetriever, ValueRetriever<?> contextRetriever, boolean withClearButton)`

Method Summary
`protected void` `chooseCategory()`
`JButton` `getChangeButton()`
`Object` `getContext()`
`String` `getDialogTitle()`
`Filter<? super Category<?>>` `getFilter()`
`Category<?>` `getRelevantValue()` returns the relevant value for this instance at the time of calling
`TreeCellRenderer` `getRenderer()`
`String` `getRootTitle()`
`JTextField` `getTextField()`
`boolean` `isEditable()`
`void` `setDialogTitle(String dialogTitle)`
`void` `setEditable(boolean flag)`
`void` `setFilter(Filter<? super Category<?>> filter)`
`void` `setRelevantValue(Category<?> value)` sets the relevant value for this instance with the given value
`void` `setRenderer(TreeCellRenderer renderer)`
`void` `setRootTitle(String rootTitle)`

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JCategoryField

    public JCategoryField(Collection<Category<?>> topCategories,
                          Object context)

### JCategoryField

    public JCategoryField(Collection<Category<?>> topCategories,
                          Object context,
                          boolean withClearButton)

### JCategoryField

    public JCategoryField(List<? extends Category<?>> topCategories,
                          Object context)

### JCategoryField

    public JCategoryField(List<? extends Category<?>> topCategories,
                          Object context,
                          boolean withClearButton)

### JCategoryField

    public JCategoryField(DBClassStore<?> store)

  convenience constructor assuming that the given store implements `CategoryManager` and is based on a category using the `Database` as context

### JCategoryField

    public JCategoryField(CategoryManager cmanager,
                          Object context)

### JCategoryField

    public JCategoryField(CategoryManager cmanager,
                          ValueRetriever<?> contextReceiver)

### JCategoryField

    public JCategoryField(ValueRetriever<Collection<Category<?>>> topCategoriesRetriever,
                          ValueRetriever<?> contextRetriever)

### JCategoryField

    public JCategoryField(ValueRetriever<Collection<Category<?>>> topCategoriesRetriever,
                          ValueRetriever<?> contextRetriever,
                          boolean withClearButton)

Method Detail

### getContext

    public Object getContext()
                      throws IOException

  Throws:
    `IOException`

### getRootTitle

    public String getRootTitle()

### setRootTitle

    public void setRootTitle(String rootTitle)

### getDialogTitle

    public String getDialogTitle()

### setDialogTitle

    public void setDialogTitle(String dialogTitle)

### getFilter

    public Filter<? super Category<?>> getFilter()

### setFilter

    public void setFilter(Filter<? super Category<?>> filter)

### getRenderer

    public TreeCellRenderer getRenderer()

### setRenderer

    public void setRenderer(TreeCellRenderer renderer)

### getTextField

    public JTextField getTextField()

### getChangeButton

    public JButton getChangeButton()

### chooseCategory

    protected void chooseCategory()
                           throws IOException

  Throws:
    `IOException`

### isEditable

    public boolean isEditable()

  Specified by:
    `isEditable` in interface `EditableComponent`

### setEditable

    public void setEditable(boolean flag)

  Specified by:
    `setEditable` in interface `EditableComponent`

### getRelevantValue

    public Category<?> getRelevantValue()

  Description copied from interface: `ValueRetriever`
  returns the relevant value for this instance at the time of calling

  Specified by:
    `getRelevantValue` in interface `ValueRetriever<Category<?>>`

### setRelevantValue

    public void setRelevantValue(Category<?> value)

  Description copied from interface: `ValueSetter`
  sets the relevant value for this instance with the given value

  Specified by:
    `setRelevantValue` in interface `ValueSetter<Category<?>>`

(c) Holger Antelmann since 2001- all rights reserved (contact: info@antelmann.com)
see www.antelmann.com/developer for further details and available downloads